ghc-7.0.4: The GHC API

ExternalCore

# Documentation

data Module Source

Constructors

Module Mname [Tdef] [Vdefg] |

Instances

Show Module |

data Tdef Source

Constructors

Data (Qual Tcon) [Tbind] [Cdef] |
Newtype (Qual Tcon) (Qual Tcon) [Tbind] Ty |

Instances

Show Tdef |

data Cdef Source

Constructors

Constr (Qual Dcon) [Tbind] [Ty] |
GadtConstr (Qual Dcon) Ty |

Instances

Show Cdef |

data Vdefg Source

Constructors

Rec [Vdef] |
Nonrec Vdef |

Instances

Show Vdefg |

type Vdef = (Bool, Qual Var, Ty, Exp)Source

data Exp Source

Constructors

Var (Qual Var) |
Dcon (Qual Dcon) |
Lit Lit |
App Exp Exp |
Appt Exp Ty |
Lam Bind Exp |
Let Vdefg Exp |
Case Exp Vbind Ty [Alt] |
Cast Exp Ty |
Note String Exp |
External String String Ty |
DynExternal String Ty |
Label String |

Instances

Show Exp |

data Bind Source

Constructors

Vb Vbind |
Tb Tbind |

data Alt Source

Constructors

Acon (Qual Dcon) [Tbind] [Vbind] Exp |
Alit Lit Exp |
Adefault Exp |

Instances

Show Alt |

type Vbind = (Var, Ty)Source

type Tbind = (Tvar, Kind)Source

data Ty Source

Constructors

Tvar Tvar |
Tcon (Qual Tcon) |
Tapp Ty Ty |
Tforall Tbind Ty |
TransCoercion Ty Ty |
SymCoercion Ty |
UnsafeCoercion Ty Ty |
InstCoercion Ty Ty |
LeftCoercion Ty |
RightCoercion Ty |

Instances

Show Ty |

data Kind Source

Constructors

Klifted |
Kunlifted |
Kunboxed |
Kopen |
Karrow Kind Kind |
Keq Ty Ty |

Instances

Show Kind |

data Lit Source

Constructors

Lint Integer Ty |
Lrational Rational Ty |
Lchar Char Ty |
Lstring String Ty |

Instances

Show Lit |

type Mname = Id Source

type Var = Id Source

type Tvar = Id Source

type Tcon = Id Source

type Dcon = Id Source

type Qual t = (Mname, t)Source

type Id = String Source

primMname :: Mname Source

tcArrow :: Qual Tcon Source